#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Wed Sep 11 12:07:07 2019

@author: fabiano
"""
import os
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.axis as ax
import matplotlib.figure as fig
import numpy as np
from sklearn import tree
from sklearn.neighbors import KNeighborsClassifier
from sklearn.svm import SVC
from sklearn.ensemble import RandomForestClassifier
from sklearn.cross_validation import train_test_split
from sklearn.model_selection import GridSearchCV
import seaborn as sns
from scipy import stats  
from sklearn.metrics import accuracy_score, precision_score, recall_score
from sklearn import tree
from sklearn.model_selection import cross_validate

def readDF(filename):
    path = "/Users/fabiano/Desktop/dataset test"
    os.chdir(path)
    filename = filename+".csv"
    if filename == "rawDf":
        dfRaw = pd.read_csv(filename)
        return dfRaw
    else:
        df_allStats = pd.read_csv(filename)
        df_allStats = df_allStats.rename(columns = {"0": "SMA"})
        return df_allStats
    
def excludeHeartRate(df_allStats):
    toRemove = []
    for element in df_allStats.columns:
        if "heartRate" in element or "Speed" in element:
            toRemove.append(element)
        
    df_noHeart= df_allStats.drop(toRemove, axis=1)
    return df_noHeart



def getTommaso():

    df_Tommaso = pd.read_csv("dataset_Tommaso.csv")
    return df_Tommaso
    
    df_Tommaso.to_csv(path+"/dataset_Tommaso.csv", index = None, header=True)
    labels_tomm.to_csv(path+"/labels_Tommaso.csv", index = None, header=True)
    
def getLabTomm():
    labels_tomm = pd.read_csv("labels_Tommaso.csv")
    return labels_tomm

def getLabelsdf(filename):
    labelsdf = pd.read_csv("labels.csv")
    return labelsdf 


def reassignValuesToLabel(labelsdf):
    
    labels_converted = {}
    for element in labelsdf["label"]:

        if "walk" in element:
            labelsdf.replace(to_replace=element, value="walk", inplace=True)
        elif "run" in element:
            labelsdf.replace(to_replace=element, value="run", inplace=True)
        elif "smoke" in element:
            labelsdf.replace(to_replace=element, value="smoke", inplace=True)
            
        labelsdf = pd.DataFrame(labelsdf)
    classlabel = 0;
    df_unique = pd.DataFrame(labelsdf["label"].value_counts())
    df_unique.plot.bar()
    for element in labelsdf["label"].unique():
        labelsdf.replace(to_replace = str(element),value = classlabel, inplace = True)
        labels_converted.setdefault(element, classlabel)
        classlabel+=1
    return labelsdf

def minMaxScaling (df_allStats):


    
    from sklearn import preprocessing

    # Get column names first
    names = df_allStats.columns.ravel().reshape(df_allStats.shape[1],1)
    # Create the Scaler object
    scaler = preprocessing.MinMaxScaler()
    # Fit your data on the scaler object
    scaled_df = scaler.fit_transform(df_allStats)
    scaled_df = pd.DataFrame(scaled_df, columns=names)
    return scaled_df

    
def featSelect(scaled_df, labelsdf):

    print('Elimino features avente corr>0.7 almeno con una altra features')

    
    
    
    sel = []
    for x in scaled_df.columns :
        sel = sel + [x]
        
        for y in scaled_df.columns :
            if x != y:
                [cor,p] = stats.pearsonr(scaled_df[x], scaled_df[y])
                if (abs(cor > 0.7) and p < 0.05) :
                    sel.remove(x)
                    break
                
    feat_sel = sel
    print('\nSelezionate ' + str(len(feat_sel)) + ' features')
    scaled_df = scaled_df[feat_sel]
    #scaled_df_Tom = scaled_df_Tom[feat_sel]
    print feat_sel
    
    # trying a cut on variance 
    
    variancedict = {}
    for c in scaled_df.columns.tolist():
        namecol = c[0]
        varianceNb = np.var(scaled_df[c])
        variancedict.setdefault(namecol , varianceNb)

    varDF = pd.DataFrame(variancedict, index = np.arange(0, len(variancedict))).iloc[0,:]
    varDF.plot.bar(title = "variance per feature", color = 'b')
    
    var_t = np.percentile(varDF.values, 50)
    above_threshold = np.maximum(varDF.values - var_t, 0)
    below_threshold = np.minimum(varDF.values, var_t)
    x = len(varDF.values)
    # and plot it
    fig, ax = plt.subplots()
    plt.title("Feature selection on variance")
    ax.bar(varDF.index, below_threshold, 0.35, color="r")
    ax.bar(varDF.index, above_threshold, 0.35, color="g",
            bottom=below_threshold)
    plt.xticks(varDF.index, rotation = 90)
    # horizontal line indicating the threshold
    ax.plot([-1, 42], [var_t, var_t], "k--")
    
    varDF = varDF.rename(columns = {"0": "var"})
    
    
    # ELIMINO FEATURES CON VARIANZA < varianza media totale
    feat_sel = []
    feat_unsel = []
    for x in list(scaled_df.columns) :
       
        var = np.var(scaled_df[x])
        if var > var_t :
            feat_sel = feat_sel + [x]
        else :
            feat_unsel = feat_unsel +[x]
    print('\nSelezionate ' + str(len(feat_sel)) + ' features')
    print feat_sel
    df_var_intra = scaled_df[feat_unsel]
    df_var_intra = df_var_intra.join(labelsdf)
    df_var_intra=df_var_intra.groupby("label").var()
    df_var_intra= df_var_intra.transpose()
    df_var_intra=df_var_intra.rename(columns = {"0":"walk", "1": "smoke", "2": "run", "3": "bike", "4":"car", "5":"cycling", "6":"elliptical", "7":"rowing"})
   
    ax = df_var_intra.plot(kind='bar')
    ax.legend(["walk", "smoke", "run", "bike", "car", "cycling", "elliptical", "rowing" ]);    
    df_var_intra.plot.bar()
    scaled_df = scaled_df[feat_sel]
    return scaled_df

def DTWDistance(s1, s2):
    
    DTW={}
    
    for i in range(len(s1)):
        DTW[(i, -1)] = float('inf')
    for i in range(len(s2)):
        DTW[(-1, i)] = float('inf')
    DTW[(-1, -1)] = 0

    for i in range(len(s1)):
        for j in range(len(s2)):
            dist= (s1[i]-s2[j])**2
            DTW[(i, j)] = dist + min(DTW[(i-1, j)],DTW[(i, j-1)], DTW[(i-1, j-1)])
		
    return np.sqrt(DTW[len(s1)-1, len(s2)-1])
#
def DTW_KNN(dfRaw,):
    #queste righe vanno commentate poi
    X_raw = dfRaw["acceleration_mod"].values.tolist()
    Xx = []
    for element in X_raw:
        element = element[1:-1]
        element = map (float, element.split(", "))
        Xx = np.append(Xx, element)
    Xx = Xx.reshape(1054,250)
    X_raw = Xx
    X_raw = zNorm(X_raw)
            
    y_raw = dfRaw["label"].values.ravel()
    indices = range(len(X_raw))
    X_train, X_test, y_train, y_test,indices_train,indices_test = train_test_split(X_raw, labelsdf,indices, test_size=0.2, stratify = labelsdf)
    
    
    knn_dtw = KNeighborsClassifier(metric = DTWDistance, n_neighbors = 1).fit(X_train, y_train.values.ravel())
    from joblib import dump, load
    dump(knn_dtw, 'knn_dtw.joblib') 
    clf = knn_dtw
    classifier = "KNN with Dynamic Time Warping"
    scoring = ['precision_macro', 'recall_macro','f1_macro', 'accuracy']
    scores_knn_dtw = cross_validate(knn_dtw, X_train, y_train.values.ravel(), scoring=scoring,
                        cv=3)
    crossValidationResultsPlot(scores_knn_dtw, classifier)
    confusionMatrix(y_test, X_test, classifier, clf)
    

        

def classification(scaled_df, labelsdf, classifier):

    X = scaled_df.values.ravel().reshape(len(scaled_df),len(scaled_df.columns))
    y =  labelsdf.values.reshape(len(labelsdf))
    labels = labelsdf.values
    indices = range(len(X))
    X_train, X_test, y_train, y_test,indices_train,indices_test = train_test_split(X, labels,indices, test_size=0.2, stratify = labels)
    scoring = ['recall_macro','precision_macro', 'f1_macro', 'accuracy']
 
    if classifier == "DecisionTree":
        classifier = "Decision Tree"
        param_grid = {'criterion' : ['gini','entropy'], 'splitter' : ['best', 'random'], 'max_features' : ['auto', 'log2', len(scaled_df.columns) ]}
        dt = tree.DecisionTreeClassifier()
        dt_gscv = GridSearchCV(dt, param_grid, cv=5)
        dt_gscv.fit(X_train,y_train)
        dt_gscv.best_score_
        params_dt_full = dt_gscv.best_params_

        scores_dt_noHR = cross_validate(dt_gscv.best_estimator_, X_train, y_train.ravel(), scoring=scoring,
                            cv=5)
        
        clf =dt_gscv.best_estimator_
        crossValidationResultsPlot(scores_dt_noHR, classifier)
        cm_dt_full = confusionMatrix(y_test, X_test, classifier, clf)
        cm_dt_full = cm_dt_full.astype('float') / cm_dt_full.sum(axis=1)[:, np.newaxis]
        cm_dt_full.diagonal()
        np.mean(cm_dt_full.diagonal())
        from joblib import dump, load
        dump(clf, 'dt_noHRnoGPS.joblib') 
        from sklearn.externals.six import StringIO  
        from IPython.display import Image  
        from sklearn.tree import export_graphviz
        import pydotplus
        
        dot_data = StringIO()
        export_graphviz(clf, out_file=dot_data,
                        feature_names= scaled_df.columns,  
                        class_names= ["walk", "smoke", "run", "bike", "car", "cycling", "elliptical", "rowing" ],  
                        filled=True, rounded=True,
                        special_characters=True)
        graph = pydotplus.graph_from_dot_data(dot_data.getvalue())  
        Image(graph.create_png())
        plot_learning_curve(clf, classifier+" learning curve", X_train, y_train, ylim=None, cv=5,
                        n_jobs=None, train_sizes=np.linspace(.1, 1.0, 5))
        
    
       
    elif classifier == "SVC":
        classifier = "Support Vector Machine"
        kernels = ['rbf', 'poly', 'linear']
        gammas = np.arange(1,10, 1)
        cs = np.arange(0.1,10.1, 1)
        decision_function_shape = ['ovr', 'ovo']
        
        svc = SVC()
        param_grid = {'kernel' : kernels, 'gamma' : gammas, 'C': cs, 'decision_function_shape' : decision_function_shape}
        svc_gscv =GridSearchCV(svc, param_grid, cv=5)
        svc_gscv.fit(X_train,y_train.ravel())
        params_svc_full = svc_gscv.best_params_
        svc_gscv.best_score_
        clf = svc_gscv.best_estimator_
        scores_svc_full = cross_validate(svc_gscv.best_estimator_, X_train, y_train.ravel(), scoring=scoring, cv = 5)
        crossValidationResultsPlot(scores_svc_full, classifier)
        cm_svc_full = confusionMatrix(y_test, X_test, classifier, clf)
        cm_svc_full = cm_svc_full.astype('float') / cm_svc_full.sum(axis=1)[:, np.newaxis]
        cm_svc_full.diagonal()
        print(np.mean(cm_svc_full.diagonal()))
       
        from joblib import dump, load
        dump(clf, 'svc_full.joblib') 
        plot_learning_curve(clf, classifier+" learning curve", X_train, y_train.ravel(), ylim=None, cv=5,
                        n_jobs=None, train_sizes=np.linspace(.1, 1.0, 5))
    elif classifier == "KNeighbors":
        classifier = "K Nearest Neighbour"
        knn2 = KNeighborsClassifier()
        #create a dictionary of all values we want to test for n_neighbors
        param_grid = {'n_neighbors': np.arange(1, 10,2), 'algorithm' : [ 'ball_tree', 'kd_tree', 'brute'],'leaf_size': np.arange(10,20, 5), 'metric' : ['euclidean', 'manhattan', 'chebyshev']}
        #use gridsearch to test all values for n_neighbors
        knn_gscv = GridSearchCV(knn2, param_grid, cv=5)
        #fit model to data
        knn_gscv.fit(X_train, y_train.ravel())
        knn_params_full = knn_gscv.best_params_
        knn_gscv.best_score_
        scores_knn_full = cross_validate(knn_gscv.best_estimator_, X_train, y_train.ravel(), scoring=scoring,
                            cv=5)
        crossValidationResultsPlot(scores_knn_full, classifier)
        clf = knn_gscv.best_estimator_
        cm_knn_full = confusionMatrix(y_test, X_test, classifier, clf)
        cm_knn_full = cm_knn_full.astype('float') / cm_knn_full.sum(axis=1)[:, np.newaxis]
        cm_knn_full.diagonal()
        #those are for accuracy in single class and average accuracy
        np.mean(cm_knn_full.diagonal())
        
        plot_learning_curve(clf, classifier+" learning curve", X_train, y_train.ravel(), ylim=None, cv=5,
                        n_jobs=None, train_sizes=np.linspace(.1, 1.0, 5))
        from joblib import dump, load
        dump(clf, 'knn_full.joblib') 
    elif classifier == "Random Forest":

        classifier = "Random Forest"
        param_grid = {'n_estimators' : [2, 4, 8, 16, 32, 64, 100, 200], 'criterion' : ['gini','entropy'], 'max_features' : ['auto', 'log2', len(scaled_df.columns)]}
        rf = RandomForestClassifier()
        rf_gscv = GridSearchCV(rf, param_grid, cv=5)
        rf_gscv.fit(X_train,y_train.ravel())
        rf_gscv.best_score_
        
        params_rf_full = rf_gscv.best_params_
        scores_rf_full = cross_validate(rf_gscv.best_estimator_, X_train, y_train.ravel(), scoring=scoring,
                            cv=5)
        crossValidationResultsPlot(scores_rf_full, classifier)
        clf = rf_gscv.best_estimator_
        cm_rf_full = confusionMatrix(y_test, X_test, classifier, clf)
        cm_rf_full = cm_rf_full.astype('float') / cm_rf_full.sum(axis=1)[:, np.newaxis]
        cm_rf_full.diagonal()

        np.mean(cm_rf_full.diagonal())
        from joblib import dump, load
        dump(clf, 'rf_full.joblib') 
        plot_learning_curve(clf, classifier+" learning curve", X_train, y_train.ravel(), ylim=None, cv=5,
                        n_jobs=None, train_sizes=np.linspace(.1, 1.0, 5))
    

def crossValidationResultsPlot(scores, classifier):
    test_recall = scores['test_recall_macro']    
    train_recall = scores["train_recall_macro"]
    test_precision = scores["test_precision_macro"]
    train_precision = scores["train_precision_macro"]
    test_accuracy = scores["test_accuracy"]
    train_accuracy = scores["train_accuracy"]
    test_f1 = scores["test_f1_macro"]
    train_f1 = scores["train_f1_macro"]
    test_recall_mean = np.mean(test_recall)
    test_recall_std = np.std(test_recall)
    train_recall_mean = np.mean(train_recall)
    train_recall_std = np.std(train_recall)
    test_precision_mean = np.mean(test_precision)
    test_precision_std = np.std(test_precision)
    train_precision_mean = np.mean(train_precision)
    train_precision_std = np.std(train_precision)
    test_f1_mean = np.mean(test_f1)
    test_f1_std = np.std(test_f1)
    train_f1_mean = np.mean(train_f1)
    train_f1_std = np.std(train_f1)
    test_accuracy_mean = np.mean(test_accuracy)
    test_accuracy_std = np.std(test_accuracy)
    train_accuracy_mean = np.mean(train_accuracy)
    train_accuracy_std = np.std(train_accuracy)
    means_train = [train_recall_mean, train_precision_mean, train_f1_mean, train_accuracy_mean ]
    means_test = [test_recall_mean, test_precision_mean, test_f1_mean, test_accuracy_mean]
    std_train = [train_recall_std, train_precision_std, train_f1_std, train_accuracy_std]
    std_test = [test_recall_std, test_precision_std, test_f1_std, test_accuracy_std]
    xpos = np.arange(len(means_train))
    fig, ax = plt.subplots()
    ax.bar(np.arange(len(means_train)), means_train, yerr=std_train, align='center', alpha=0.5, ecolor='black', capsize=10)
    ax.set_ylabel('Scores')
    ax.set_xticks(xpos)
    ax.set_xticklabels(scoring)
    ax.set_title('5-fold cross validation indicators for '+ classifier+' - Training set')
    ax.yaxis.grid(True)
    fig, ax = plt.subplots()
    ax.bar(np.arange(len(means_train)), means_test, yerr=std_test, align='center', alpha=0.5, ecolor='black', capsize=10)
    ax.set_ylabel('Scores')
    ax.set_xticks(xpos)
    ax.set_xticklabels(scoring)
    ax.set_title('5-fold cross validation indicators for '+ classifier+' - Validation set')
    ax.yaxis.grid(True)
    lab = ["fit time", "test_accuracy", "test_precision", "test_recall", "test_f1_macro", "train_accuracy", "train_precision", "train_recall", "train_f1_macro"]
    fit_time =scores["fit_time"]
    score_time = scores["score_time"]
    test_recall = scores['test_recall_macro']    
    train_recall = scores["train_recall_macro"]
    test_precision = scores["test_precision_macro"]
    train_precision = scores["train_precision_macro"]
    test_accuracy = scores["test_accuracy"]
    train_accuracy = scores["train_accuracy"]
    test_f1 = scores["test_f1_macro"]
    train_f1 = scores["train_f1_macro"]
    plt.show()
    x = np.arange(len(fit_time))
    width = 0.35
    plt.bar(x,fit_time)
    plt.title('Time for fitting model with 5-fold-CV - '+ classifier)
    plt.ylabel('seconds')
    ax.set_xticks(x)
    ax.legend()
    fig.tight_layout()
    plt.show()
    plt.bar(x,score_time)
    plt.title('Time for scoring with 5-fold-CV - '+ classifier)
    plt.ylabel('seconds')
    ax.set_xticks(x)
    ax.legend()
    fig.tight_layout()
    plt.show()
    
    

    
def confusionMatrix(y_test, X_test, classifier, clf):
    
    from sklearn.metrics import confusion_matrix, classification_report, accuracy_score
    import seaborn as sns
    lbl = ["walk", "smoke", "run", "bike", "car", "cycling", "elliptical", "rowing" ]
    y_pred = clf.predict(X_test)
    cm = confusion_matrix(y_test, y_pred)
    sns.heatmap(cm, square=True, annot=True, fmt='d', cbar=False,
            xticklabels=lbl,
            yticklabels=lbl)
    plt.title("Confusion matrix on test set -"+classifier)
    plt.xlabel('true label')
    plt.ylabel('predicted label');
    print(classification_report(y_test, y_pred, target_names = lbl, digits = 4))
    return cm

def tommasoTestCM(scaled_df, labels_tomm, df_Tommaso, classifier, clf):
    scaled_df_Tommaso = minMaxScaling(df_Tommaso)
    scaled_df_Tommaso = scaled_df_Tommaso[scaled_df.columns]
   

    
    lbl = ["walk", "smoke", "run", "bike", "car", "cycling", "elliptical", "rowing" ]
    y_pred = clf.predict(scaled_df_Tommaso.values)
   
    cm = confusion_matrix(labels_tomm.values, y_pred)
    sns.heatmap(cm, square=True, annot=True, fmt='d', cbar=False,
            xticklabels=lbl,
            yticklabels=lbl)
    plt.title("Confusion matrix on test set -"+classifier)
    plt.xlabel('true label')
    plt.ylabel('predicted label');
    print("Accuracy: "+str(accuracy_score(labels_tomm.values, y_pred)))
    print(classification_report(labels_tomm.values, y_pred, target_names = lbl, digits = 4))


def main():
    filename = raw_input("Insert filename of dataset : ")
    df = readDF(filename)
    labelsdf = getLabelsdf()
    labelsdf = reassignValuesToLabel(labelsdf)
    considerHeartRate = raw_input("Do you want to exclude heart rate and GPS? press y/n")
    if considerHeartRate == "y":
        df = excludeHeartRate(df)
    
    df = minMaxScaling (df);
    df = featSelect(df, labelsdf)
    classifier = raw_input("Which classifier ?: Choose between DecisionTree" +
                               "kNeighbors, SVC, RandomForest \n")
        
    classification(df, labelsdf, classifier)




def plot_learning_curve(estimator, title, X, y, ylim=None, cv=None,
                        n_jobs=None, train_sizes=np.linspace(.1, 1.0, 5)):
    import numpy as np
    import matplotlib.pyplot as plt
    from sklearn.model_selection import learning_curve

    """
    Generate a simple plot of the test and training learning curve.

    Parameters
    ----------
    estimator : object type that implements the "fit" and "predict" methods
        An object of that type which is cloned for each validation.

    title : string
        Title for the chart.

    X : array-like, shape (n_samples, n_features)
        Training vector, where n_samples is the number of samples and
        n_features is the number of features.

    y : array-like, shape (n_samples) or (n_samples, n_features), optional
        Target relative to X for classification or regression;
        None for unsupervised learning.

    ylim : tuple, shape (ymin, ymax), optional
        Defines minimum and maximum yvalues plotted.

    cv : int, cross-validation generator or an iterable, optional
        Determines the cross-validation splitting strategy.
        Possible inputs for cv are:
          - None, to use the default 3-fold cross-validation,
          - integer, to specify the number of folds.
          - :term:`CV splitter`,
          - An iterable yielding (train, test) splits as arrays of indices.

        For integer/None inputs, if ``y`` is binary or multiclass,
        :class:`StratifiedKFold` used. If the estimator is not a classifier
        or if ``y`` is neither binary nor multiclass, :class:`KFold` is used.

        Refer :ref:`User Guide <cross_validation>` for the various
        cross-validators that can be used here.

    n_jobs : int or None, optional (default=None)
        Number of jobs to run in parallel.
        ``None`` means 1 unless in a :obj:`joblib.parallel_backend` context.
        ``-1`` means using all processors. See :term:`Glossary <n_jobs>`
        for more details.

    train_sizes : array-like, shape (n_ticks,), dtype float or int
        Relative or absolute numbers of training examples that will be used to
        generate the learning curve. If the dtype is float, it is regarded as a
        fraction of the maximum size of the training set (that is determined
        by the selected validation method), i.e. it has to be within (0, 1].
        Otherwise it is interpreted as absolute sizes of the training sets.
        Note that for classification the number of samples usually have to
        be big enough to contain at least one sample from each class.
        (default: np.linspace(0.1, 1.0, 5))
    """
    
    plt.figure()
    plt.title(title)
    if ylim is not None:
        plt.ylim(*ylim)
    plt.xlabel("Training examples")
    plt.ylabel("Score")
    train_sizes, train_scores, test_scores = learning_curve(
        estimator, X, y, cv=cv, n_jobs=n_jobs, train_sizes=train_sizes)
    train_scores_mean = np.mean(train_scores, axis=1)
    train_scores_std = np.std(train_scores, axis=1)
    test_scores_mean = np.mean(test_scores, axis=1)
    test_scores_std = np.std(test_scores, axis=1)
    plt.grid()

    plt.fill_between(train_sizes, train_scores_mean - train_scores_std,
                     train_scores_mean + train_scores_std, alpha=0.1,
                     color="r")
    plt.fill_between(train_sizes, test_scores_mean - test_scores_std,
                     test_scores_mean + test_scores_std, alpha=0.1, color="g")
    plt.plot(train_sizes, train_scores_mean, 'o-', color="r",
             label="Training score")
    plt.plot(train_sizes, test_scores_mean, 'o-', color="g",
             label="Cross-validation score")

    plt.legend(loc="best")
    return plt 
    

main()
    
    
    