# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

import json
import os
#import scipy.signal
import scipy.io







def timeWindowingJsonAcquisitionConTimestamp(datastore):
    element_freq_50 = ["accelerationX", "accelerationY", "accelerationZ", 
                       "gyroX", "gyroY", "gyroZ", "yaw","pitch", "roll"]
    
    for element in datastore:
        if element in element_freq_50:
            datastore[element] = datastore[element][200:-200]
        inizioAcquisizione = datastore["startDataAcquisition"]+4 #200/50
        fineAcquisizione = datastore["stopDataAcquisition"]-4    
    
    lung_finestra = 250;
    dataset={}
    
    for element in datastore :
        if element in element_freq_50:
            element = str(element)
            for i in range (0, len(datastore[element]),lung_finestra):
                if i + lung_finestra > len(datastore[element]):
                    continue;
                else:
                    value = datastore[element][i:i+lung_finestra]
                    dataset.setdefault(element, []).append({str(element) : value})  
        if element in ["locatioUpdates"] :
            element = str(element)
            durataFin = 5; #in secondi
            speed = []
            for finestra in range(int(inizioAcquisizione+durataFin), int (fineAcquisizione), durataFin):
                speed = []
                for item in datastore[element]:
                    tempo = item["timeStampAcquistion"]
                    if finestra+durataFin > fineAcquisizione:
                        if (tempo >= finestra and tempo <fineAcquisizione):
                            speed.append(item["currentSpeed"])
                    if (tempo >= finestra and tempo <(finestra+durataFin)):
                        speed.append(item["currentSpeed"])
                dataset.setdefault("currentSpeed", []).append({"currentSpeed" : speed})
        if element in ["heartUpdates"] :
            element = str(element)
            durataFin = 5; #in secondi
            for finestra in range(int(inizioAcquisizione), int (fineAcquisizione), durataFin):
                heartRate = []
                #for i in range(0,len(datastore[element])):
                for item in datastore[element]:
                    tempo = item["timeStampAcquistion"]
                    if finestra+durataFin > fineAcquisizione:
                        if (tempo >= finestra and tempo <fineAcquisizione):
                             heartRate.append(item["heartRate"])
                    if (tempo >= finestra and tempo <(finestra+durataFin)):
                        heartRate.append(item["heartRate"])
                dataset.setdefault("heartRate", []).append({"heartRate" : heartRate})
    for  i in range(0, len(datastore["gyroX"]) / lung_finestra ) :
        dataset.setdefault("label", []).append({"label" : datastore["label"]})
    definitivo = {}
    lung = min(len(dataset["heartRate"]), len(dataset["currentSpeed"]))
    for i in range (0, lung):
        print i
        for element in dataset:
            definitivo.setdefault(str(i), {})
            definitivo[str(i)].setdefault(element, dataset[element][i].values()[0])
    return definitivo

def concatenateSamples(definitivo, nuovo):
    import pandas as pd
    
    if definitivo.empty==True:
        definitivo = pd.DataFrame(nuovo).transpose()
        return definitivo
    else:
        nuovo = pd.DataFrame(nuovo).transpose()
        definitivo = definitivo.append(nuovo, ignore_index = True)
        return definitivo
    
def deleteRowsWithNoValues(df):
    import pandas as pd
    rowToDelete = []
    for i in range (0, len(df)):
    #itero su tutte le righe
        for element in df:
            if df[element][i] == []:
                rowToDelete.append(i)
                
    
    df = df.drop(rowToDelete, axis =0)
    index = range(0,len(df))
    df = df.set_index(pd.Series(index))
    return df

"""
scelgo di rimpiazzare con 0 se la media è minore o uguale a 0
                        con 1 se media > 0
"""
def replaceMinusOneInCurrentSpeed(df):
    for i in range (0, len(df)):
        meanCS = sum(df.loc[i, :]["currentSpeed"])/len((df.loc[i, :]["currentSpeed"]))
        if (meanCS > 0):
            for j in range(len(df.loc[i, :]["currentSpeed"])):
                if df.loc[i, :]["currentSpeed"][j] == -1:
                    df.loc[i, :]["currentSpeed"][j] = meanCS;
        else:
            for j in range(len(df.loc[i, :]["currentSpeed"])):
                if df.loc[i, :]["currentSpeed"][j] == -1:
                    #qui forse devo buttarli
                    df.loc[i, :]["currentSpeed"][j] = 0;
    return df

###################################
def calculateIMA(df):

    ima = {}
    
    #se faccio un for per inizializzare ima funziona lo stesso
    for i in range (0, len(df)):
        ax = 0
        ay = 0
        az = 0
        #qui itero su tutti gli elementi del dataframe
        ima.setdefault(str(i), 0)
        for j in range (0, len(df.loc[i, :]["accelerationX"])):
            ax += abs(df.loc[i, :]["accelerationX"][j])
            ay += abs(df.loc[i, :]["accelerationY"][j])
            az += abs(df.loc[i, :]["accelerationZ"][j])
        ima[str(i)] = ax+ay+az
        
# il problema è che ho finestre di durata troppo diversa:
# devo spezzare in modo tale che ogni item abbia 500 campioni
    index = range(0, len(ima))
    newdf = pd.DataFrame(ima, index = index).iloc[0,:]
    newdf = newdf.transpose()
    return newdf

def FFT(array):
#import matplotlib.pyplot as plt
   
    yf = np.fft.rfft(array)
    return yf

####################################

def calculateCorrelations(df):             
    from scipy.stats.stats import pearsonr   
    # restituisce il coefficiente di correlazione di Pearson e il p value(2 valori)
    df_corr = pd.DataFrame()
    for row in range (0, len(df)):
        #alpha = 0.05
        corrs = {}
        acc_corr_xy = pearsonr(df["accelerationX"][row], df["accelerationY"][row])
        acc_corr_yz = pearsonr(df["accelerationY"][row], df["accelerationZ"][row])
        acc_corr_xz = pearsonr(df["accelerationX"][row], df["accelerationZ"][row])
        gyro_corr_xy = pearsonr(df["gyroX"][row], df["gyroY"][row])
        gyro_corr_yz = pearsonr(df["gyroY"][row], df["gyroZ"][row])
        gyro_corr_xz = pearsonr(df["gyroX"][row], df["gyroZ"][row])
        corr_roll_yaw = pearsonr(df["roll"][row], df["yaw"][row])
        corr_roll_pitch = pearsonr(df["roll"][row], df["yaw"][row])
        corr_yaw_pitch = pearsonr(df["yaw"][row], df["pitch"][row])
        #ci sono altre correlazioni che possono essere utili?
        corrs.setdefault("acc_corr_xy", []).append(acc_corr_xy)
        corrs.setdefault("acc_corr_xz", []).append(acc_corr_xz)
        corrs.setdefault("acc_corr_yz",[]).append(acc_corr_yz)
        corrs.setdefault("gyro_corr_xy",[]).append(gyro_corr_xy)
        corrs.setdefault("gyro_corr_xz",[]).append(gyro_corr_xz)
        corrs.setdefault("gyro_corr_yz",[]).append(gyro_corr_yz)
        corrs.setdefault("corr_roll_yaw",[]).append(corr_roll_yaw)
        corrs.setdefault("corr_roll_pitch",[]).append(corr_roll_pitch)
        corrs.setdefault("corr_yaw_pitch",[]).append(corr_yaw_pitch)
        
        for key, value in corrs.items():
#            if value[0][1] > alpha:
#                corrs[key] = -2
#               
#            else:
            corrs[key] = corrs[key][0][0]
        df_value = pd.DataFrame(corrs, index = [row])
        df_corr = df_corr.append(df_value)
    return df_corr
    
def statsFeatures(df, row ):
    import numpy as np
    from scipy.stats import skew, kurtosis, entropy
    statsfeatures = {}
    if "index" in df.columns:
        df = df.drop(["index"], axis = 1)
    for element in df:
        if element != "label":
            #ho element che è la colonna, row che è la riga
            mean = np.mean(df[element][row])
            statsfeatures.setdefault("mean_"+element,[] ).append(mean)
            var = np.var(df[element][row])
            statsfeatures.setdefault("var_"+element,[] ).append(var)
            std = np.std(df[element][row])
            statsfeatures.setdefault("std_"+element,[] ).append(std)
            skewn = skew (df[element][row])
            statsfeatures.setdefault("skewn_"+element,[] ).append(skewn)
            kurt = kurtosis(df[element][row])
            statsfeatures.setdefault("kurt_"+element,[] ).append(kurt)
            maximum = np.max(df[element][row])
            statsfeatures.setdefault("maximum_"+element,[] ).append(maximum)
            peaktopeak = np.max(df[element][row])-np.min(df[element][row])
            statsfeatures.setdefault("peaktopeak_"+element,[] ).append(peaktopeak)
            zero_crossings = zero_cross(df[element][row])
            statsfeatures.setdefault("zero_crossings_"+element,[] ).append(zero_crossings)
            # IMA Per accelerazione, già fatto

            if element not in ["heartRarte","currentSpeed", "yaw","pitch", "roll"]:
                #essendo serie temporali brevi non ha senso 
                # analizzarle in frequenza
                fft = FFT(df[element][row])
                mean = np.real(np.mean(fft))
                statsfeatures.setdefault("mean_fft_"+element,[] ).append(mean)
                var = np.real(np.var(fft))
                statsfeatures.setdefault("var_fft_"+element,[] ).append(var)
                std = np.real(np.std(fft))
                statsfeatures.setdefault("std_fft_"+element,[] ).append(std)
                skewn = np.real(skew (fft))
                statsfeatures.setdefault("skewn_fft_"+element,[] ).append(skewn)
                kurt = np.real(kurtosis(fft))
                statsfeatures.setdefault("kurt_fft_"+element,[] ).append(kurt)
                maximum = np.real(max(fft))
                statsfeatures.setdefault("max_fft_"+element,[] ).append(maximum)
                peaktopeak = np.real(max(fft) - min (fft))
                statsfeatures.setdefault("ptp_fft_"+element,[] ).append(peaktopeak)
    return statsfeatures

def excludeHeartRate(df):
    df_noHeart= df.drop("heartRate", axis=1)
    return df_noHeart

def excludeGPS(df):
    df_noGPS =  df.drop("currentSpeed", axis=1)
    return df_noGPS
#devo vedere di riaggiungere l'entropia che non ha senso buttata lì così
        
    
def zero_cross(sig):
     # Find all indices right before a rising-edge zero crossing
   sig = sig-np.mean(sig)
   zero_crossings = len(np.where(np.diff(np.sign(sig)))[0])
   return zero_crossings
            
def createDataset():
    import json
    import os
    import time
    import scipy.io
    import numpy as np
    import matplotlib.pyplot as plt
    path = raw_input("insert path: suggested /Users/fabiano/Desktop/tesi/dataset ")
    os.chdir(path)
    import pandas as pd
    i = 0
    df = pd.DataFrame()
    for element in os.listdir(path):
        i=i+1
        filename = element
        if filename == ".DS_Store":
            continue
        if filename=="dataset.csv":
            continue
        if filename[0] == ".":
            filename = filename[1:]
        if filename[-7:] == ".icloud":
            filename = filename[:-7]
        print filename
        time.sleep(1)
        if filename:
            with open(filename, 'r') as f:
                datastore = json.load(f)
                print (f)
                dataelement = timeWindowingJsonAcquisitionConTimestamp(datastore)
                df = concatenateSamples(df, dataelement)
    return df


    # devo metterci l'ima e le correlazioni
#df_ima = calculateIMA(df)
#
#dtf = 0
#dtf = df_allStats.join(df_ima, how = "left")#qui va df_ima

            

def exportDatasetCSV(path, df):
    export_csv = df_allStats.to_csv(path+"/dataset.csv", index = None, header=True)
    





# in labels quindi ho un dataframe con cui posso rimappare le label in modo numerico





                
       



#from scipy.fftpack import fft
#df[element][0] = df[element][0] -np.mean(df[element][0])
#res = FFT(df[element][0])
## Plotting the results
#N = 250
## sample spacing
#T = 1.0 / 50.0
#x = np.linspace(0.0, N*T, N)
#y = df[element][0]
#yf = fft(y)
#from scipy.signal import blackman
#w = blackman(N)
#ywf = fft(y*w)
#xf = np.linspace(0.0, 1.0/(2.0*T), N//2)
#import matplotlib.pyplot as plt
#plt.semilogy(xf[1:N//2], 2.0/N * np.abs(yf[1:N//2]), '-b')
#plt.semilogy(xf[1:N//2], 2.0/N * np.abs(ywf[1:N//2]), '-r')
#plt.legend(['FFT', 'FFT w. window'])
#plt.grid()
#plt.show()

#import numpy as np
#for i in range (0, len(df)):
#    y = df[element][i] -np.mean(df[element][i])
#    res = np.fft.fft(y)
#    # Plotting the results
#    f_s = 50
#    freq = np.linspace(0, 1 / f_s, len(y))
#    plt.plot(freq,res)
#    plt.xlabel('Frequency (Hz)')
#    plt.title('Frequency Domain ');
#    plt.show()
#    time.sleep(2)

# ellittica, vogatore, walk tutto, run, bike
#ellittica = []
#vogatore = []
#walk = []
#run = []
#bike = []
#
#for row in range(0, len(df)):
#    if df["label"][row] == "ellittica":
#        ellittica.append(np.mean(df["currentSpeed"][row]))
#    elif df["label"][row] == "vogatore":
#        vogatore.append(np.mean(df["currentSpeed"][row]))
#    elif df["label"][row] == "bike":
#        bike.append(np.mean(df["currentSpeed"][row]))
#    elif df["label"][row] == "vogatore":
#        vogatore.append(np.mean(df["currentSpeed"][row]))
#    elif "walk" in df["label"][row]:
#        walk.append(np.mean(df["currentSpeed"][row]))
#    elif "run" in df["label"][row]:
#        run.append(np.mean(df["currentSpeed"][row]))
#    
#x = np.arange(0, 20).transpose()
#
#        
#plt.figure()
#fig, ax = plt.subplots()
#plt.plot(ellittica[:20])
#plt.plot(vogatore[:20])
#plt.plot(walk[:20])
#plt.plot(run[:20])
#plt.plot(bike[:20])
#
#ax.legend( ("ellittica", "vogatore", "bike", "walk", "run"))
#
#plt.show()
#data = [ellittica, vogatore, bike, walk, run]
#plt.figure()
#fig, ax = plt.subplots()
#plt.boxplot(data)
#
#ax.legend( ("ellittica", "vogatore", "bike", "walk", "run"))
#
#plt.show()
#ellittica = []
#vogatore = []
#walk = []
#run = []
#bike = []
#for row in range(0, len(df)):
#    if df["label"][row] == "ellittica":
#        ellittica.append(np.mean(df["heartRate"][row]))
#    elif df["label"][row] == "vogatore":
#        vogatore.append(np.mean(df["heartRate"][row]))
#    elif df["label"][row] == "bike":
#        bike.append(np.mean(df["heartRate"][row]))
#    elif df["label"][row] == "vogatore":
#        vogatore.append(np.mean(df["heartRate"][row]))
#    elif "walk" in df["label"][row]:
#        walk.append(np.mean(df["heartRate"][row]))
#    elif "run" in df["label"][row]:
#        run.append(np.mean(df["heartRate"][row]))
#
#plt.figure()
#fig, ax = plt.subplots()
#plt.plot(ellittica[:20])
#plt.plot(vogatore[:20])
#plt.plot(walk[:20])
#plt.plot(run[:20])
#plt.plot(bike[:20])
#
#ax.legend( ("ellittica", "vogatore", "bike", "walk", "run"))
#
#plt.show()
#data = [ellittica, vogatore, bike, walk, run]
#plt.figure()
#fig, ax = plt.subplots()
#plt.boxplot(data)
#
#ax.legend( ("ellittica", "vogatore", "bike", "walk", "run"))
#plt.show
#from scipy.fftpack import fft,fftfreq,rfftfreq     
#plt.subplot(311)
#plt.subplots_adjust( hspace = 1)
#plt.title("xspec aX - aY vog ")
#xy = plt.xcorr(df["accelerationX"][74], df["accelerationY"][74], usevlines=True, maxlags=50, normed=True, lw=2)
#xspec_xy = fft(xy[1])
#f_s = 50
#freqs = np.where((fftfreq(len(xy[1])) * f_s) > 0, (fftfreq(len(xy[1])) * f_s), 0)
#plt.plot(freqs,xspec_xy)
#plt.subplot(312)
#plt.subplots_adjust( hspace = 1)
#plt.title("xspec aX - aZ vog")
#xz = plt.xcorr(df["accelerationX"][74], df["accelerationZ"][74], usevlines=True,maxlags=50,  normed=True, lw=2)
#xspec_xz = fft(xz[1]-np.mean(xz[1]))
#
#freqs = np.where((fftfreq(len(xz[1])) * f_s) > 0, (fftfreq(len(xz[1])) * f_s), 0)
#plt.plot(freqs,xspec_xz)
#plt.subplot(313)
#plt.subplots_adjust( hspace = 1)
#plt.title("xspec aY - aZ vog")
#yz = plt.xcorr(df["accelerationZ"][74], df["accelerationY"][74], usevlines=True,maxlags=50,  normed=True, lw=2)
#xspec_yz = fft(yz[1])
#
#freqs = np.where((fftfreq(len(xz[1])) * f_s) > 0, (fftfreq(len(xz[1])) * f_s), 0)
#plt.plot(freqs,xspec_yz)
#plt.show()



# xcorr aY - aZ molto buona per walk e run anche uncont
# nell'ellittica aXY, aXZ molto regolari, aYZ meno ma forse è un bene per usarla come discriminazione
# nel vogatore la xcorr migliore sembra aXY
#le correlazioni non sono utili nel caso dell'andare in bicicletta

# ho provato le xcorr tra IMA, gyro / IMA, angoli ma risultati non interessanti
# non molto indicative le correlazioni tra acc e variazione di angoli relativi 
# facendo fft di xcorr (crossSpettro) possiamo trovare cose interessanti

# ho 118 campioni di camminata
# bike 51
# gli altri una 20

def zNorm(df_allStats):
    df_allStats = df_allStats.dropna()
    import pandas as pd
    from sklearn import preprocessing
    df_allStats
    # Get column names first
    names = df_allStats.columns.ravel().reshape(df_allStats.shape[1],1)
    # Create the Scaler object
    scaler = preprocessing.StandardScaler()
    # Fit your data on the scaler object
    scaled_df = scaler.fit_transform(df_allStats)
    scaled_df = pd.DataFrame(scaled_df, columns=names)
    return scaled_df

def featSelect(scaled_df, labelsdf):

    
    print('Elimino features avente corr>0.8 almeno con una altra features')

    
    from sklearn.feature_selection import SelectKBest
    from sklearn.feature_selection import f_classif
    import pandas as pd
    from scipy import stats  
    
    sel = []
    for x in scaled_df.columns :
        sel = sel + [x]
        
        for y in scaled_df.columns :
            if x != y:
                [cor,p] = stats.pearsonr(scaled_df[x], scaled_df[y])
                if (abs(cor > 0.8) and p < 0.05) :
                    sel.remove(x)
                    break
    feat_sel = sel
    print('\nSelezionate ' + str(len(feat_sel)) + ' features')
    scaled_df = scaled_df[feat_sel]
    

    #apply SelectKBest class to extract top 10 best features
    bestfeatures = SelectKBest(score_func=f_classif, k=10)
    #f_classif is anova method
    X = scaled_df
    y = labelsdf.values.ravel()
    fit = bestfeatures.fit(X,y)
    dfscores = pd.DataFrame(fit.scores_)
    dfcolumns = pd.DataFrame(X.columns)
    #concat two dataframes for better visualization 
    featureScores = pd.concat([dfcolumns,dfscores],axis=1)
    featureScores.columns = ['Specs','Score']  #naming the dataframe columns
    print(featureScores.nlargest(10,'Score'))
    sel = featureScores.nlargest(10,'Score')['Specs'].values
    scaled_df = scaled_df[sel]
    return scaled_df




def clustering(scaled_df, labels, labelsdf, feat_sel ):
    X = scaled_df.values.ravel().reshape(len(scaled_df),len(feat_sel))
    measures = []
    from sklearn.cluster import KMeans
    from sklearn.metrics import homogeneity_completeness_v_measure
    for k in range(len(labelsdf["label"].unique()),len(labelsdf["label"].unique())+10):
        kmeans = KMeans(n_clusters=k)
        kmeans.fit(X)
        y_kmeans = kmeans.predict(X)
        y_kmeans = y_kmeans.ravel().reshape(len(labelsdf))
        labels = labelsdf.values.ravel().reshape(len(labelsdf))
        #qui labels è l'indicazione della classe per ogni campione
        measures.append(homogeneity_completeness_v_measure(labels, y_kmeans))
    hom = []
    compl = []
    v_m = []
    for element in measures:
        hom.append(element[0])
        compl.append(element[1])
        v_m.append(element[2])
    return measures

def plotClustMeasures(hom, compl, v_m):
    import matplotlib.pyplot as plt 
    lab = ['homogeneity', 'completeness', 'v measure']
    x = np.arange(len(measures))
    width = 0.35
    
    rects1 = ax.bar(x-width/4, hom, width/2, label=lab[0])
    rects2 = ax.bar(x , compl, width/2, label=lab[1])
    rects3 = ax.bar(x+width/4, v_m, width/2, label=lab[2])
    ax.set_ylabel('Scores')
    ax.set_xlabel('Number of clusters from 6 to 16')
    ax.set_title('Clustering measures')
    ax.set_xticks(x)
    ax.legend()
    fig.tight_layout()
    plt.show()
    
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.colors import LogNorm
from sklearn import mixture
from sklearn import metrics
labels = labelsdf.values.ravel().reshape(len(labelsdf),1)
clf = mixture.GaussianMixture(n_components=6, covariance_type='full')
clf.fit(X)
y_mgm = clf.predict_proba(X)
yclust_mgm = clf.predict(X)
from sklearn.metrics import homogeneity_completeness_v_measure
measures = homogeneity_completeness_v_measure(labels, y_kmeans, beta = 0.5)
result = pd.DataFrame(data = {"clust" : y_kmeans, "lab" :labels, "mgm" : clf.predict(X).reshape(len(labelsdf))} )




def classification(scaled_df, labelsdf, tuning, classifier):
    from sklearn import tree
    from sklearn.neighbors import KNeighborsClassifier
    from sklearn.svm import SVC
    from sklearn.ensemble import RandomForestClassifier
    from sklearn.cross_validation import train_test_split
    from sklearn.neural_network import MLPClassifier
    from sklearn.model_selection import GridSearchCV
    X = scaled_df.values.ravel().reshape(len(scaled_df),len(scaled_df.columns))
    labels = labelsdf.values
    indices = range(len(X))
    X_train, X_test, y_train, y_test,indices_train,indices_test = train_test_split(X, labels,indices, test_size=0.33, stratify = labelsdf["label"].values)
    
    
    if classifier == "DecisionTree":
        clf = tree.DecisionTreeClassifier(criterion = 'gini', class_weight=None, max_depth=None,
            max_features=None, max_leaf_nodes=None,
            min_impurity_decrease=0.0, min_impurity_split=None,
            min_samples_leaf=1, min_samples_split=2,
            splitter='best')
        if tuning == "y":
            parameter_space = {
                    'min_weight_fraction_leaf' :np.arange(0.1, 0.6, 0.25),
                    'random_state' : np.arange(1,101, 1)}
            clf = GridSearchCV(clf, parameter_space, n_jobs=-1, cv=6)
        clf.fit(X_train, y_train)
        
    
       
    elif classifier == " SVC":
        clf = SVC()
        if tuning == "y":
            parameter_space = {
                    'C' : np.arange(1.0, 10.5, 0.5),
                    'kernel' : ['rbf', 'linear', 'poly', 'sigmoid'],
                    'coef0': np.arange(0.0, 15.5, 0.5),
                    'tol': np.arange(1e-3, 5e-2, 1e-4),
                    'decision_function_shape' : ['ovo', 'ovr']}
            clf = GridSearchCV(clf, parameter_space, n_jobs=-1, cv=3)
        clf = clf.fit(X_train, y_train.reshape(len(y_train)))
        
    elif classifier == "KNeighbors":
        clf = KNeighborsClassifier(algorithm='auto', leaf_size=30, metric='minkowski',
           metric_params=None, n_jobs=1)
        if tuning == "y":
            parameter_space = {
                    'n_neighbors' : np.arange(1,21,1),
                    'weigths' : ['uniform', 'distance'],
                    'p' : [1,2]}
            clf = GridSearchCV(clf, parameter_space, n_jobs=-1, cv=3)
        clf = clf.fit(X_train, y_train.reshape(len(y_train)))
        
    elif classifier == "Random Forest":
        clf = RandomForestClassifier()
        if tuning == "y":
            parameter_space = {
                    ''}
        clf = clf.fit(X_train, y_train.reshape(len(y_train)))  
    elif classifier == "MLP":
        clf = MLPClassifier()
        if tuning == "y":
            parameters = {'solver': ['lbfgs'], 'max_iter': [1000,1100,1200,1300,1400,1500,1600,1700,1800,1900,2000 ], 'alpha': 10.0 ** -np.arange(1, 10), 'hidden_layer_sizes':np.arange(10, 15), 'random_state':[0,1,2,3,4,5,6,7,8,9]}
            clf = GridSearchCV(clf, parameters, n_jobs=-1)
        clf = clf.fit(X_train, y_train.reshape(len(y_train)))
        
    if tuning == "y":
        return clf.best_estimator_
    
    return clf
    
    
    
def crossValidation(clf, X, labelsdf, classifier):
    from sklearn.model_selection import cross_validate
    scoring = ['precision_macro', 'recall_macro', 'accuracy']
    scores = cross_validate(clf, X, labelsdf.values.reshape(len(labelsdf)), scoring=scoring,
                            cv=6)
    sorted(scores.keys())
    lab = ["fit time", "test_accuracy", "test_precision", "test_recall", "train_accuracy", "train_precision", "train_recall"]
    fit_time =scores["fit_time"]
    test_recall = scores['test_recall_macro']    
    train_recall = scores["train_recall_macro"]
    test_precision = scores["test_precision_macro"]
    train_precision = scores["train_precision_macro"]
    test_accuracy = scores["test_accuracy"]
    train_accuracy = scores["train_accuracy"]
    performance = [np.mean(fit_time), np.mean(test_accuracy), np.mean(test_precision), 
                   np.mean(test_recall),np.mean(train_accuracy), np.mean(train_precision), np.mean(train_recall)]
    y_pos = y_pos = np.arange(len(lab)-1)
    plt.bar(y_pos, performance[1:], align='edge', width=0.3)
    plt.xticks(y_pos, lab[1:], rotation = 45)
    plt.ylabel('Scores')
    plt.title('Average Classification measures with 6-fold-CV - '+ classifier)
    plt.show()
    x = np.arange(len(fit_time))
    width = 0.35
    plt.bar(x,fit_time)
    plt.title('Time fitting with 6-fold-CV - '+classifier)
    plt.ylabel('seconds')
    ax.set_xticks(x)
    ax.legend()
    fig.tight_layout()
    plt.show()

def confusionMatrix(indices_test, labels, y):
    from sklearn.metrics import confusion_matrix, accuracy_score, precision_score, recall_score, f1_score
    labels = labels[indices_test]
    cm = confusion_matrix(labels, y)
    return cm

cm = confusion_matrix(labels, y)
accuracy = float(accuracy_score(labels, y))
recall = np.diag(cm).astype(float) / np.sum(cm, axis = 1)
precision = np.diag(cm).astype(float) / np.sum(cm, axis = 0)
    

cm_knn = confusion_matrix(labels[indices_test], y_knn)
accuracy_knn = float(accuracy_score(labels[indices_test], y_dt))
recall_knn = np.diag(cm_knn).astype(float) / np.sum(cm_knn, axis = 1)
precision_knn = np.diag(cm_knn).astype(float) / np.sum(cm_knn, axis = 0)

cm_svc = confusion_matrix(labels[indices_test], y_svc)
accuracy_svc = float(accuracy_score(labels[indices_test], y_svc))
recall_svc = np.diag(cm_svc).astype(float) / np.sum(cm_svc, axis = 1)
precision_svc = np.diag(cm_svc).astype(float) / np.sum(cm_svc, axis = 0)

cm_rf = confusion_matrix(labels[indices_test], y_rf)
accuracy_rf = float(accuracy_score(labels[indices_test], y_rf))
recall_rf = np.diag(cm_rf).astype(float) / np.sum(cm_rf, axis = 1)
precision_rf = np.diag(cm_rf).astype(float) / np.sum(cm_rf, axis = 0)



def reassignValuesToLabel(labelsdf):
    import pandas as pd
    for element in labelsdf:
        if "walk" in element:
            labelsdf.replace(to_replace=element, value="walk", inplace=True)
        elif "run" in element:
            labelsdf.replace(to_replace=element, value="run", inplace=True)
        elif "smoke" in element:
             labelsdf.replace(to_replace=element, value="smoke", inplace=True)
        labelsdf = pd.DataFrame(labelsdf)
    classlabel = 0;
    df_unique = pd.DataFrame(labelsdf["label"].value_counts())
    df_unique.plot.bar()
    for element in labelsdf["label"].unique():
        labelsdf.replace(to_replace = str(element),value = classlabel, inplace = True)
        classlabel+=1
        labels_converted.setdefault(element, classlabel)
    return labelsdf

def getLabelDict(labelsdf):

    classlabel = 0;

    for element in labelsdf["label"].unique():
        labelsdf.replace(to_replace = str(element),value = classlabel, inplace = True)
        classlabel+=1
        labels_converted.setdefault(element, classlabel)
    return labels_converted

def getLabelsdf(df):
    labelsdf = df["label"]
    return labelsdf 

def getLabelDescr(df):
    import pandas as pd
    labels_converted = {}
    #unique labels with number of samples
    df_unique = pd.DataFrame(df["label"].value_counts())
    df_unique.plot.bar()
    label = 0
    index = []
    for element in df_unique.index:
        labels_converted.setdefault(element, label)
        label+=1
        index.append(label)
    
    labels = pd.DataFrame(labels_converted, index = index)
    labels = labels.drop_duplicates()
    labels.index.name = "Numerical Label"
    labels = labels.append(df_unique)
    labels = labels.drop(["label"],axis=1)
    labels = labels.dropna()
    return labels


def createFeatDataset():
    import pandas as pd
    
    df = createDataset()
    df = deleteRowsWithNoValues(df)
    df = replaceMinusOneInCurrentSpeed(df)
    df = df.sort_values("label")
    df = df.reset_index()
    df_allStats = pd.DataFrame()
    typedf = raw_input("Do you want full dataset, no heart rate, no gps, or no both?: Type full, nohr, nogps, nob ")
    
    if typedf == "nohr":
        df = excludeHeartRate()
    elif typedf == "nogps":
        df = excludeGPS()
    elif typedf == "nob":
        df = excludeHeartRate()
        df = excludeGPS()
    for row in range (0, len(df)):
        print row
    #itero su tutte le righe
        df_stats = pd.DataFrame()
        df_stats = pd.DataFrame.from_dict(statsFeatures(df, row ))
        df_allStats = df_allStats.append(df_stats, ignore_index = True)
    return df_allStats

def main():
    df_allStats = createFeatDataset()
#1 createFeatDataset
#2 getLabeldf
#3 reassignValuesToLabel
#4 getlabelDescr
#5 zNorm
#6 featSelect
#7 classification
#8 confusionMatrix


